"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const users_1 = require("./users");
const server_1 = require("@fugazi/connector/scripts/bin/server");
const DEFAULT_USER = new users_1.User({
    gender: "ADVANCED",
    name: "system user",
    key: "qwe123",
    excaliburClearance: "TOP_SECRET"
});
function normInputString(input) {
    return input ? input.replace('\\\n', '') : '';
}
exports.normInputString = normInputString;
function normInputNumber(input) {
    switch (typeof input) {
        case 'number':
            return input;
        case 'string':
            return Number.parseInt(input);
    }
    throw new Error(`wrong kind of number ${JSON.stringify(input)}`);
}
exports.normInputNumber = normInputNumber;
function withUser(h) {
    return (request) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        try {
            const result = yield h(request, DEFAULT_USER);
            return {
                status: server_1.ResponseStatus.Success,
                data: result
            };
        }
        catch (error) {
            return {
                status: server_1.ResponseStatus.Failure,
                data: error.message
            };
        }
    });
    /*
        return async (request: Request) => {
            try {
                const userData = request.session.user;
                if (userData) {
                    const result = await h(request, new User(userData));
                    return {
                        status: ResponseStatus.Success,
                        data: result
                    };
                } else {
                    return {
                        status: ResponseStatus.Failure,
                        data: 'You must be logged in'
                    };
                }
            } catch (error) {
                return {
                    status: ResponseStatus.Failure,
                    data: error.message
                };
            }
        };*/
}
exports.withUser = withUser;
//# sourceMappingURL=command-utils.js.map