"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const server_1 = require("@fugazi/connector/scripts/bin/server");
function init(builder, users) {
    builder
        .descriptor({
        title: "session"
    })
        .command('login', {
        title: 'login',
        description: "log in to the system",
        returns: "string",
        syntax: `login (name string) (password string)`
    })
        .handler((request) => {
        const name = request.data('name');
        const password = request.data('password');
        request.session.user = users.findUserByLogin(name, password);
        if (!request.session.user) {
            return {
                status: server_1.ResponseStatus.Failure,
                data: 'no matching user record found'
            };
        }
        return {
            status: server_1.ResponseStatus.Success,
            data: `Welcome to Fugazi, ${request.session.user.name}, your Excalibur clearance is ${request.session.user.excaliburClearance}.`
        };
    })
        .parent()
        .command('whoami', {
        title: 'whoami',
        description: "display logged in user in current session",
        returns: "string",
        syntax: ['whoami']
    })
        .handler((request) => {
        if (request.session.user) {
            return {
                status: server_1.ResponseStatus.Success,
                data: `you are ${request.session.user.name}, your Excalibur clearance is ${request.session.user.excaliburClearance}.`
            };
        }
        else {
            return {
                status: server_1.ResponseStatus.Success,
                data: 'no logged in user found'
            };
        }
    });
}
exports.default = init;
//# sourceMappingURL=commands.js.map