"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const path_1 = require("path");
const clearence_1 = require("../excalibur/clearence");
var Gender;
(function (Gender) {
    Gender[Gender["MALE"] = 0] = "MALE";
    Gender[Gender["FEMALE"] = 1] = "FEMALE";
    Gender[Gender["ADVANCED"] = 2] = "ADVANCED";
})(Gender = exports.Gender || (exports.Gender = {}));
class UserData {
}
exports.UserData = UserData;
class User {
    constructor(ud) {
        this.gender = Gender[ud.gender];
        this.name = ud.name;
        this.key = ud.key;
        this.excaliburClearance = clearence_1.ExcaliburSecClass[ud.excaliburClearance];
    }
    isPermitted(reqPermission) {
        return this.excaliburClearance >= reqPermission;
    }
}
exports.User = User;
class Users {
    constructor(fs) {
        this.users = [];
        this.init(fs);
    }
    findUserByLogin(name, password) {
        return this.users.find(u => u.name.toLowerCase() === name.toLowerCase() && u.key.toLowerCase() === password.toLowerCase());
    }
    init(fs) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const usersStr = yield fs.loadTextFile(Users.usersConfigPath);
            fs.events.on('fileChanged', (e) => {
                if (path_1.normalize(e.fullPath) === path_1.normalize(Users.usersConfigPath)) {
                    console.log('detected users config change');
                    this.parseUsers(e.newContent);
                }
            });
            this.parseUsers(usersStr);
        });
    }
    parseUsers(usersStr) {
        try {
            this.users = JSON.parse(usersStr);
        }
        catch (e) {
            console.error(`error parsing ${Users.usersConfigPath} : ${e.message}`);
        }
    }
}
exports.Users = Users;
Users.usersConfigPath = 'users.json';
//# sourceMappingURL=users.js.map