"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const chai_1 = require("chai");
const timing_1 = require("../../src/core/timing");
function delay(timeout) {
    return new Promise(r => setTimeout(r, timeout));
}
describe('setTimedInterval', () => {
    it('works', () => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        const deltas = [];
        let timer = timing_1.setTimedInterval(delta => deltas.push(delta), 10);
        try {
            yield new Promise(res => setTimeout(res, 100));
            chai_1.expect(deltas.length).to.be.gte(5);
            deltas.forEach((delta) => {
                chai_1.expect(delta).to.be.gt(5);
                chai_1.expect(delta).to.be.lt(20);
            });
        }
        finally {
            clearInterval(timer);
        }
    }));
});
//# sourceMappingURL=timing.spec.js.map