"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const chai_1 = require("chai");
const logic_1 = require("../../src/ecr/logic");
const model_1 = require("../../src/ecr/model");
const timing_1 = require("../../src/core/timing");
const test_kit_1 = require("./test-kit");
// just some number. any number should do
const GAIN_PER_MILLISECOND = 0.123;
describe('test-driver', () => {
    it('getLinearDeriviation', () => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        chai_1.expect(yield test_kit_1.getLinearDeriviation(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () { return Date.now(); }), {
            iterations: 10,
            graceFactor: 0.1,
            tickInterval: 1
        })).to.be.approximately(1, 0.1);
        chai_1.expect(yield test_kit_1.getLinearDeriviation(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () { return Date.now() * 2; }), {
            iterations: 10,
            graceFactor: 0.1,
            tickInterval: 1
        })).to.be.approximately(2, 0.1);
    }));
    it('getLinearOverloadDeriviation', () => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        const graceFactor = 0.1;
        const status = new model_1.SwitchBoard(model_1.ESwitchBoard.A2);
        let timer = timing_1.setTimedInterval(delta => {
            status.overload = status.overload + (GAIN_PER_MILLISECOND * delta);
        }, logic_1.EcrLogic.tickInterval);
        try {
            chai_1.expect(yield test_kit_1.getLinearOverloadDeriviation(status, graceFactor)).to.be.approximately(GAIN_PER_MILLISECOND, GAIN_PER_MILLISECOND * graceFactor);
        }
        finally {
            clearInterval(timer);
        }
    }));
});
//# sourceMappingURL=test-kit.spec.js.map