"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const osc_1 = require("osc");
const rxjs_1 = require("rxjs");
const oscServer = new osc_1.UDPPort({
    localAddress: "0.0.0.0",
    localPort: 57121,
    remotePort: 8888,
    // remoteAddress: "127.0.0.1",
    remoteAddress: "10.0.0.45",
});
// Listen for incoming OSC bundles.
oscServer.on("bundle", function (bundle, timeTag, info) {
    console.log("An OSC bundle just arrived for time tag", timeTag, ":", bundle);
    console.log("Remote info is: ", info);
});
// Listen for incoming OSC bundles.
oscServer.on("message", function (message, timeTag, info) {
    console.log("An OSC message just arrived :", message);
    console.log("Remote info is: ", info);
});
oscServer.open();
rxjs_1.interval(500).subscribe(i => {
    console.log(i);
    oscServer.send({
        address: '/hello',
        args: ['world', i]
        //          args: ['world', i]
    });
});
//# sourceMappingURL=send-osc.js.map